
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class PagesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pages = await db.pages.create(
            {
                id: data.id || undefined,
        
        page_key: data.page_key
        ||
        null
            ,
            
        title: data.title
        ||
        null
            ,
            
        slug: data.slug
        ||
        null
            ,
            
        meta_title: data.meta_title
        ||
        null
            ,
            
        meta_description: data.meta_description
        ||
        null
            ,
            
        meta_keywords: data.meta_keywords
        ||
        null
            ,
            
        hero_heading: data.hero_heading
        ||
        null
            ,
            
        hero_subheading: data.hero_subheading
        ||
        null
            ,
            
        content: data.content
        ||
        null
            ,
            
        is_published: data.is_published
        ||
        false
        
            ,
            
        published_at: data.published_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await pages.setAuthor( data.author || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.pages.getTableName(),
                belongsToColumn: 'hero_background_images',
                belongsToId: pages.id,
            },
            data.hero_background_images,
            options,
        );
        

        return pages;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const pagesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                page_key: item.page_key
            ||
            null
            ,
            
                title: item.title
            ||
            null
            ,
            
                slug: item.slug
            ||
            null
            ,
            
                meta_title: item.meta_title
            ||
            null
            ,
            
                meta_description: item.meta_description
            ||
            null
            ,
            
                meta_keywords: item.meta_keywords
            ||
            null
            ,
            
                hero_heading: item.hero_heading
            ||
            null
            ,
            
                hero_subheading: item.hero_subheading
            ||
            null
            ,
            
                content: item.content
            ||
            null
            ,
            
                is_published: item.is_published
            ||
            false
        
            ,
            
                published_at: item.published_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const pages = await db.pages.bulkCreate(pagesData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < pages.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.pages.getTableName(),
                    belongsToColumn: 'hero_background_images',
                    belongsToId: pages[i].id,
                },
                data[i].hero_background_images,
                options,
            );
        }
        

        return pages;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const pages = await db.pages.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.page_key !== undefined) updatePayload.page_key = data.page_key;
        
        
        if (data.title !== undefined) updatePayload.title = data.title;
        
        
        if (data.slug !== undefined) updatePayload.slug = data.slug;
        
        
        if (data.meta_title !== undefined) updatePayload.meta_title = data.meta_title;
        
        
        if (data.meta_description !== undefined) updatePayload.meta_description = data.meta_description;
        
        
        if (data.meta_keywords !== undefined) updatePayload.meta_keywords = data.meta_keywords;
        
        
        if (data.hero_heading !== undefined) updatePayload.hero_heading = data.hero_heading;
        
        
        if (data.hero_subheading !== undefined) updatePayload.hero_subheading = data.hero_subheading;
        
        
        if (data.content !== undefined) updatePayload.content = data.content;
        
        
        if (data.is_published !== undefined) updatePayload.is_published = data.is_published;
        
        
        if (data.published_at !== undefined) updatePayload.published_at = data.published_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await pages.update(updatePayload, {transaction});

        
        
        if (data.author !== undefined) {
            await pages.setAuthor(
              
              data.author,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.pages.getTableName(),
                belongsToColumn: 'hero_background_images',
                belongsToId: pages.id,
            },
            data.hero_background_images,
            options,
        );
        

        return pages;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const pages = await db.pages.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of pages) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of pages) {
                await record.destroy({transaction});
            }
        });


        return pages;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const pages = await db.pages.findByPk(id, options);

        await pages.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await pages.destroy({
            transaction
        });

        return pages;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const pages = await db.pages.findOne(
            { where },
            { transaction },
        );

        if (!pages) {
            return pages;
        }

        const output = pages.get({plain: true});

        
        
        
        
        
        output.cta_buttons_page = await pages.getCta_buttons_page({
            transaction
        });
        
        
        output.feature_highlights_page = await pages.getFeature_highlights_page({
            transaction
        });
        
        
        output.galleries_page = await pages.getGalleries_page({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.testimonials_page = await pages.getTestimonials_page({
            transaction
        });
        
        
        
        
        
        
        
        output.hero_background_images = await pages.getHero_background_images({
            transaction
        });
        
        
        output.author = await pages.getAuthor({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'author',
        
        where: filter.author ? {
          [Op.or]: [
            { id: { [Op.in]: filter.author.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.author.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



      {
        model: db.file,
        as: 'hero_background_images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'title',
                        filter.title,
                    ),
                };
            }
            
            if (filter.slug) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'slug',
                        filter.slug,
                    ),
                };
            }
            
            if (filter.meta_title) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'meta_title',
                        filter.meta_title,
                    ),
                };
            }
            
            if (filter.meta_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'meta_description',
                        filter.meta_description,
                    ),
                };
            }
            
            if (filter.meta_keywords) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'meta_keywords',
                        filter.meta_keywords,
                    ),
                };
            }
            
            if (filter.hero_heading) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'hero_heading',
                        filter.hero_heading,
                    ),
                };
            }
            
            if (filter.hero_subheading) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'hero_subheading',
                        filter.hero_subheading,
                    ),
                };
            }
            
            if (filter.content) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'pages',
                        'content',
                        filter.content,
                    ),
                };
            }
            

            
            

            
            if (filter.published_atRange) {
                const [start, end] = filter.published_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    published_at: {
                    ...where.published_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.page_key) {
                where = {
                    ...where,
                page_key: filter.page_key,
            };
            }
            
            if (filter.is_published) {
                where = {
                    ...where,
                is_published: filter.is_published,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.pages.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'pages',
                        'title',
                        query,
                    ),
                ],
            };
        }

        const records = await db.pages.findAll({
            attributes: [ 'id', 'title' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['title', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.title,
        }));
    }

    
};

